#ifndef CIVASSEMBLY_H
#define CIVASSEMBLY_H
#include "CivTypes.h"
#include <list>

class CivAssembly;
class CivNode;
class CivPipe;
class CivTank;
class CivValve;
class CivPumps;
class CivEmitters;
class CivCoordinates;
class CivMixing;
class CivLabels;
class CivTags;

/**
	 
*/
class CivAssembly
{
public:
	virtual Str toString();
};

/**
   ڵ
 */
class CivNode: public CivAssembly
{
public:
	typedef struct  Table
	{
		// ; ID              	Elev        	Demand      	Pattern
		Str ID;
		Str Elev;
		Str Demand;
		Str PatternId;
	}  NodeTable;

	void addItem(NodeTable table);
	void addItems(std::list<NodeTable> tables);

	std::list<NodeTable> mTables;
};

/**
 * 
 */
class CivPipe: public CivAssembly
{
public:
	typedef struct  Table
	{
		// ; ID  Node1   Node2   Length   Diameter  	Roughness  MinorLoss  Status
		Str ID;
		Str Node1;
		Str Node2;
		Str Length;
		Str Diameter;
		Str Roughness;
		Str MinorLoss;
		Str Status;
	}  PipesTable;

	void addItem(PipesTable table);
	void addItems(std::list<PipesTable> tables);

	std::list<PipesTable> mTables;
};


/*
	ˮ
*/
class CivTank:public CivAssembly
{
public:
	typedef struct  Table
	{
		// ; ID              	Elevation   	InitLevel   	MinLevel    	MaxLevel    	Diameter    	MinVol      	VolCurve
		Str ID;
		Str Elev;
		Str InitLevel;
		Str MinLevel;
		Str MaxLevel;
		Str Diameter;
		Str MinVol;
		Str VolCurve;
	}  TankTable;

	void addItem(TankTable table);
	void addItems(std::list<TankTable> tables);

	std::list<TankTable> mTables;
};

/*
 ڹпƷš
*/
class CivValve :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
			ŵIDǩ
			ʼڵID
			ֹڵID
			ֱmmӢ磩
			
			
			ֲʧϵ
		*/
		Str ID;
		Str Node1;
		Str Node2;
		Str Diameter;
		Str Type;
		Str Setting;
		Str MinorLoss;
	}  ValveTable;

	void addItem(ValveTable table);
	void addItems(std::list<ValveTable> tables);

	std::list<ValveTable> mTables;
};

/**
  ˮ
*/
class CivPumps :public CivAssembly
{
public:
	typedef struct  Table
	{
		// ;ID              	Node1           	Node2           	Parameters
		Str ID;
		Str Node1;
		Str Node2;
		Str Parameters;
	}  PumpTable;

	void addItem(PumpTable table);
	void addItems(std::list<PumpTable> tables);

	std::list<PumpTable> mTables;
};

/*
аˮڵ
*/
class CivReservoirs :public CivAssembly
{
public:
	typedef struct  Table
	{
		/* 
			IDǩ
			ˮͷft(m)
			ˮͷģʽIDѡ
		*/
		Str ID;
		Str Head;
		Str Pattern;
	}  ReservoirsTable;

	void addItem(ReservoirsTable table);
	void addItems(std::list<ReservoirsTable> tables);

	std::list<ReservoirsTable> mTables;
};

/**
   EMITTERSģڵ㶨Ϊɢ߿׿ڣ
*/
class CivEmitters :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
			ӽڵIDǩ
			ϵ1ף1 psiѹµλ
		*/
		Str ID;
		Str coeff;
	}  EmittersTable;

	void addItem(EmittersTable table);
	void addItems(std::list<EmittersTable> tables);
	std::list<EmittersTable> mTables;
};

/**
  
*/
class CivCoordinates :public CivAssembly
{
public:
	typedef struct  Table
	{
		// ; ;Node            	X-Coord         	Y-Coord
		Str ID;
		Str XCoord;
		Str YCoord;
	}  CoordTable;

	void addItem(CoordTable table);
	void addItems(std::list<CoordTable> tables);

	std::list<CoordTable> mTables;
};

/**
	ѡ
*/
class  CivMixing :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
			ˮIDǩ
			ģͣMIXED, 2COMP, FIFOLIFO
			ҵݻС
		*/
		Str ID;
		Str hyModel;
		Str volume;
	}  MixingTable;

	void addItem(MixingTable table);
	void addItems(std::list<MixingTable> tables);

	std::list<MixingTable> mTables;
};

/**
   ȷˮػϵģ͡
*/
class CivParameter :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
			[OPTIONS]
			[TIMES]
			[REACTIONS]
			[ENERGY] 
			[REPORT]
		*/
		Str name;
		Str val;
	} ParamTable;

	void addItem(ParamTable table);
	void addItems(std::list<ParamTable> tables);

	void setType(const std::string& type) { mType = type; }

	std::string mType;
	std::list<ParamTable> mTables;
};

/**
  ģʽ
*/
class CivPatterns :public CivAssembly
{
public:
	typedef struct  Table
	{
		Str name; // ģʽ
		Str val; // ģʽֵ
	} PatternTable;

	void addItem(PatternTable table);
	void addItems(std::list<PatternTable> tables);

	std::list<PatternTable> mTables;
};

/*
	߼XY㡣
*/
class CivCurves :public CivAssembly
{
public:
	typedef struct  Table
	{
		Str ID; // ģʽ
		Str XCoord; // Xֵ
		Str YCoord; // Yֵ
	} CurvesTable;

	void addItem(CurvesTable table);
	void addItems(std::list<CurvesTable> tables);

	std::list<CurvesTable> mTables;
};

/**
	ӽڵĶģʽˮǶ[JUNCTIONS]Ĳ䡣
*/
class CivDemands :public CivAssembly
{
public:
	typedef struct  Table
	{
		/* 
			ӽڵIDǩ
		    ˮλ
			ˮģʽIDѡ
			ֺ֮ˮƣѡ
		*/
		Str ID; 
		Str BaseDemand; 
		Str PatternId; 
		Str DemandType;
	} DemandsTable;

	void addItem(DemandsTable table);
	void addItems(std::list<DemandsTable> tables);

	std::list<DemandsTable> mTables;
};

// ˮԴͷλá
class  CivSources :public CivAssembly 
{
public:
	typedef struct  Table
	{
		/*
		ڵIDǩ
        ԴͷͣCONCEN, MASS, FLOWPACEDSETPOINT
        ׼Դͷǿ
        ʱģʽIDѡ;Node            	Type        	Quality     	Pattern
		*/
		Str ID;
		Str Type;
		Str Quality;
		Str Pattern;
	} CurvesTable;

	void addItem(CurvesTable table);
	void addItems(std::list<CurvesTable> tables);

	std::list<CurvesTable> mTables;
};

// ģ⿪ʼʱѡܶεĳʼ״̬
class CivStatus :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		   ܶIDǩ
           ״̬ ID              	Status/Setting
		*/
		Str ID;
		Str Setting;
	} StatusTable;

	void addItem(StatusTable table);
	void addItems(std::list<StatusTable> tables);

	std::list<StatusTable> mTables;
};

// ڵĳʼˮʡ
class CivQuality :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		    ڵIDǩ
            ʼˮ
		*/
		Str ID;
		Str InitQuality;
	} QualityTable;

	void addItem(QualityTable table);
	void addItems(std::list<QualityTable> tables);

	std::list<QualityTable> mTables;
};

// ͼǩֵ
class CivLabels :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		  X
		  Y
		   ˫еıǩı
		   êڵIDǩѡ
		*/
		Str XCoord;
		Str YCoord;
		Str Label;
		Str ID;
	} LabelTable;

	void addItem(LabelTable table);
	void addItems(std::list<LabelTable> tables);

	std::list<LabelTable> mTables;
};

// ͱǩضڵ͹ܶ
class CivTags :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		   ؼΪNODELINK
		   ڵ߹ܶIDǩ
		   ǩı޿ո
		*/
		Str Key;
		Str Id;
		Str Label;
	} TagsTable;

	void addItem(TagsTable table);
	void addItems(std::list<TagsTable> tables);

	std::list<TagsTable> mTables;
};

#endif // !CIVASSEMBLY_H

